#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityTouchingFishLevelReward.h"
std::auto_ptr<M_ActivityTouchingFishLevelReward> M_ActivityTouchingFishLevelReward::msSingleton(nullptr);

int M_ActivityTouchingFishLevelReward::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityTouchingFishLevelRewardData* M_ActivityTouchingFishLevelReward::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityTouchingFishLevelRewardData>& M_ActivityTouchingFishLevelReward::GetMapData()
{
	return mMapData;
}

void M_ActivityTouchingFishLevelReward::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityTouchingFishLevelReward.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityTouchingFishLevelRewardData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* NorItem = element->Attribute("NorItem");
			std::vector<std::string> vecNorItem;
			boost::split(vecNorItem, NorItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNorItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNorItem[i].c_str(), &temp))
				{
					data.mNorItem.push_back(temp);
				}
			}
		}
		{
			const char* NorCount = element->Attribute("NorCount");
			std::vector<std::string> vecNorCount;
			boost::split(vecNorCount, NorCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNorCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNorCount[i].c_str(), &temp))
				{
					data.mNorCount.push_back(temp);
				}
			}
		}
		{
			const char* AdvItem = element->Attribute("AdvItem");
			std::vector<std::string> vecAdvItem;
			boost::split(vecAdvItem, AdvItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAdvItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAdvItem[i].c_str(), &temp))
				{
					data.mAdvItem.push_back(temp);
				}
			}
		}
		{
			const char* AdvCount = element->Attribute("AdvCount");
			std::vector<std::string> vecAdvCount;
			boost::split(vecAdvCount, AdvCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAdvCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAdvCount[i].c_str(), &temp))
				{
					data.mAdvCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityTouchingFishLevelReward Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityTouchingFishLevelReward::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityTouchingFishLevelReward");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityTouchingFishLevelReward");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityTouchingFishLevelRewardData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "NorItem", data.mNorItem);
		LuaCfgHelper::readVectorInt(L, "NorCount", data.mNorCount);
		LuaCfgHelper::readVectorInt(L, "AdvItem", data.mAdvItem);
		LuaCfgHelper::readVectorInt(L, "AdvCount", data.mAdvCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityTouchingFishLevelReward Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityTouchingFishLevelReward::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityTouchingFishLevelReward* M_ActivityTouchingFishLevelReward::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityTouchingFishLevelReward());
	}
	return msSingleton.get();
}

void M_ActivityTouchingFishLevelReward::Release()
{
	msSingleton.reset(nullptr);
}
